
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "beta.h"

/* Computes log(Beta(m, n)) using table look-up.  Table size is
   determined by value of k first time function is called.  Falls back
   on explicit calculation if table lookup fails  */

double logbeta(double m, double n)
{
    return lgamma(m) + (lgamma(n) - lgamma(m+n));
}

double beta_loglik(double sum1, double sum2, int dsize, double m, double n)
{
    return -dsize * logbeta(m, n) + (m-1) * sum1 + (n-1) * sum2;
}

double beta_ll(double *x, int dsize, double m, double n)
{
    int i;
    double sum1 = 0, sum2 = 0;
    for (i = 0; i < dsize; i++) {
	sum1 += log(x[i]);
	sum2 += log(1 - x[i]);
    }
    return beta_loglik(sum1, sum2, dsize, m, n);
}

