
dyn.load("rbeta.so")

compute_beta_ll <- function(x, m = 1, n = 1)
{
    .Call("compute_beta_loglik", x, m, n)
}


x <- rbeta(10, 15, 25)

ll <- matrix(0, 30, 30)
for (i in 1:30)
    for (j in 1:30)
{
    ll[i, j] <- compute_beta_ll(x, m = i, n = j)
}

init.par <-
    c(row(ll)[which.max(ll)],
      col(ll)[which.max(ll)])

library(lattice)
wireframe(ll)

beta.negll <- function(par, data)
{
    ans <- compute_beta_ll(data, m = par[1], n = par[2])
    return (-ans)
}

optim(init.par, beta.negll, data = x, hessian = TRUE)

replicate(10, optim(c(1, 1), beta.negll, data = rbeta(50, 15, 25))$par)


replicate(10, optim(c(1, 1), beta.negll, data = rbeta(50, 15, 25), method = "Nelder")$counts)


mle.sim <- t(replicate(100, optim(c(1, 1), beta.negll, data = rbeta(50, 15, 25))$par))


ave <- function(x) {
    m <- mean(x)
    x[1:length(x)] <- m
    x
}



